/*****************************************************************************
  Copyright  2003 by Martin Cook. All rights are reserved. If you like this 
  code then feel free to go ahead and use it. The only thing I ask is that 
  you don't remove or alter my copyright notice. Your use of this software 
  is entirely at your own risk. I make no claims or warrantees about the 
  reliability or fitness of this code for any particular purpose. If you 
  make changes or additions to this code please mark your code as being 
  yours. If you have questions or comments then please contact me at: 
  martinc@outdrs.net
  
  Have Fun! :o)
*****************************************************************************/

using System;
using System.ComponentModel.Design;

namespace PrivateSettings.Design
{
	/// <summary>
	/// Editor for a SettingCollection.
	/// </summary>
	internal class SettingCollectionEditor : CollectionEditor
	{
		
		// *******************************************************************
		// Constructors.
		// *******************************************************************

		public SettingCollectionEditor(System.Type type)
			: base(type)
		{

		} // End SettingCollectionEditor()

		// *******************************************************************
		// Overrides.
		// *******************************************************************

		protected override System.Object CreateInstance(System.Type itemType)
		{

			// Should we create a new setting?
			if (itemType == typeof(Setting))
			{
				
				// Create the setting instance.
				Setting x = (Setting)base.CreateInstance(itemType);

				// Setup the default key name.
				x.StorageKey = x.Site.Name + "Key";

				return x;
			
			} // End if we should create a new setting.
            
			return base.CreateInstance(itemType);

		} // End CreateInstance()

	} // End class SettingCollectionEditor

} // End namespace PrivateSettings.Design
